=== debian/changelog ===
falcosecurity-libs (0.15.1-2ubuntu1) noble; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Ignore test failures on armhf/s390x (fixes armhf/s390x ftbfs)
    - disable LTO, fix FTBFS (fixes amd64 ftbfs)
    - Use liblua5.3-dev instead of liblua5.1-dev to fix ftbfs
      on riscv64 and ppc64el.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 16 Apr 2024 08:34:08 +0200

falcosecurity-libs (0.15.1-2) unstable; urgency=medium

  * Re-imported the 0.14.1-5.1 NMU (Closes: #1068827)
    This was forgotten by mistake

 -- Dima Kogan <dkogan@debian.org>  Thu, 11 Apr 2024 23:21:24 -0700

falcosecurity-libs (0.15.1-1ubuntu3) noble; urgency=medium

  * Also disable test failures on s390x

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 11 Apr 2024 22:21:13 +0200

falcosecurity-libs (0.15.1-1ubuntu2) noble; urgency=medium

  [ Bo YU ]
  * Use liblua5.3-dev instead of liblua5.1-dev to fix ftbfs 
    on riscv64 and ppc64el. (Closes: #1068731)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 11 Apr 2024 19:49:30 +0200

falcosecurity-libs (0.15.1-1ubuntu1) noble; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Ignore test failures on armhf (fixes armhf ftbfs)
    - disable LTO, fix FTBFS (fixes amd64 ftbfs)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 11 Apr 2024 11:01:03 +0200

falcosecurity-libs (0.15.1-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Sat, 06 Apr 2024 11:54:51 -0700

falcosecurity-libs (0.14.1-5.1ubuntu5) noble; urgency=medium

  * Rebuild against new old abseil.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 11 Apr 2024 09:56:03 +0200

falcosecurity-libs (0.14.1-5.1ubuntu4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:13:36 +0000

falcosecurity-libs (0.14.1-5.1ubuntu3) noble; urgency=medium

  * debian/patches/linux-6.8-s-strlcpy-strscpy-g.patch: 
    - Linux 6.8: fix FTBFS (LP: #2058670)

 -- Paolo Pisati <paolo.pisati@canonical.com>  Thu, 21 Mar 2024 15:53:57 +0000

falcosecurity-libs (0.14.1-5.1ubuntu2) noble; urgency=medium

  * No-change rebuild against libcurl4t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 06:14:45 +0000

falcosecurity-libs (0.14.1-5.1ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Ignore test failures on armhf (fixes armhf ftbfs)
    - disable LTO, fix FTBFS (fixes amd64 ftbfs)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 29 Feb 2024 17:12:20 +0100

falcosecurity-libs (0.14.1-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add versioned dependency on dpkg-dev to guard against accidental backports
    with wrong ABI. (Closes: #1062545)

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 29 Feb 2024 16:16:34 +1300

falcosecurity-libs (0.14.1-5ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Ignore test failures on armhf (fixes armhf ftbfs)
    - disable LTO, fix FTBFS (fixes amd64 ftbfs)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 03 Feb 2024 13:27:09 +0100

falcosecurity-libs (0.14.1-5) unstable; urgency=medium

  * Rename libraries for 64-bit time_t transition (Closes: #1062545)
    Thanks to Michael Hudson-Doyle <mwhudson@debian.org>

 -- Dima Kogan <dkogan@debian.org>  Fri, 02 Feb 2024 22:44:12 -0800

falcosecurity-libs (0.14.1-4) unstable; urgency=medium

  * Make chisels work with the separately-shipped sysdig tool

 -- Dima Kogan <dkogan@debian.org>  Thu, 01 Feb 2024 22:27:26 -0800

falcosecurity-libs (0.14.1-3ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Ignore test failures on armhf (fixes armhf ftbfs)
    - disable LTO, fix FTBFS (fixes amd64 ftbfs)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 29 Jan 2024 09:10:14 +0100

falcosecurity-libs (0.14.1-2ubuntu3) noble; urgency=medium

  * Use lua instead of luajit

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 27 Jan 2024 09:57:02 +0100

falcosecurity-libs (0.14.1-2ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Ignore test failures on armhf (fixes armhf ftbfs)
    - make sure we don't link libluajit on ppc64el and riscv64 (fixes
      ppc64el/riscv64 ftbfs)
    - disable LTO, fix FTBFS (fixes amd64 ftbfs)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 27 Jan 2024 07:27:06 +0100

falcosecurity-libs (0.14.1-1ubuntu2) noble; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Use lua everywhere (fixes arm64/s390x ftbfs)
    - Ignore test failures on armhf (fixes armhf ftbfs)
    - make sure we don't link libluajit on ppc64el and riscv64 (fixes
      ppc64el/riscv64 ftbfs)
    - disable LTO, fix FTBFS (fixes amd64 ftbfs)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 26 Jan 2024 09:57:28 +0100

falcosecurity-libs (0.11.3+repack-6ubuntu2) noble; urgency=medium

  * debian/patches/fix-driver-fixed-build-against-6.6-rc-kernel.patch:
    - Linux 6.6 FTBFS fix (LP: #2041510)

 -- Paolo Pisati <paolo.pisati@canonical.com>  Fri, 27 Oct 2023 07:41:24 +0000
