=== debian/watch ===
version=4
https://github.com/falcosecurity/libs/tags .*/(0\.\d\S+)\.tar\.gz
